package cn.aibreeze.exam.mapper;

import cn.aibreeze.exam.entity.ElehSessionQaRecordDo;
import cn.aibreeze.exam.util.ExamConstants;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

@Mapper
public interface ElehSessionQaRecordMapper extends BaseMapper<ElehSessionQaRecordDo> {


    @Select(value = "select max(question_id) from eleh_session_qa_record where tenant = #{tenant} and type = 0 and session_id = #{sessionId} and user_id = #{userId}")
    Long selectSessionMaxQuestionId(@Param("tenant") Integer tenant, @Param("sessionId") String sessionId, @Param("userId") String userId);

    @Select(value = "select * from eleh_session_qa_record where tenant = #{tenant} and type = 0 and session_id = #{sessionId} and user_id = #{userId} and question_id = #{questionId}")
    ElehSessionQaRecordDo selectQaRecord(@Param("tenant") Integer tenant, @Param("sessionId") String sessionId, @Param("userId") String userId, @Param("questionId") Long questionId);

    @Select(value = "select * from eleh_session_qa_record where tenant = #{tenant} and session_id = #{sessionId} and user_id = #{userId} and type = 1 order by created_at desc limit 1")
    ElehSessionQaRecordDo selectExamResult(@Param("tenant") Integer tenant, @Param("sessionId") String sessionId, @Param("userId") String userId);

    @Update(value = "update eleh_session_qa_record set answer = '',score_criteria='',score=null where id = #{id}")
    int clearById(@Param("id") Long id);

}
